
/**************************************************************************
 * Copyright (C) 2007 Ruben Pollan Bella <meskio@amedias.org>             *
 *                                                                        *
 *  This file is part of TuDu.                                            *
 *                                                                        *
 *  TuDu is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation; either version 3 of the License.        *
 *                                                                        *
 *  TuDu is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H

#include <fstream>
#include <map>
#include <string>
#include <cstdlib>
using namespace std;

struct key_action;
typedef map<char,key_action> key_map;
struct key_action {
	string action;
	key_map subkeys;
};
typedef map<string,string> action_list;

struct general_conf {

};

class Config
{
public:
	bool load(const char* path);
	bool getAction(char key, string& action);
	void getActionList(action_list& list);
	bool getCollapse();
	int getDaysWarn();
private:
	key_map tree_keys;
	bool collapse;
	int  days_warn_deadline;

	void getGeneralOption(string& option, string& value);
	void insertKeyMap(key_map& k, string action, string keys);
	void _getActionList(action_list& list, key_map& k, string key);
	int getContext(string& str);
};

#endif
