
/**************************************************************************
 * Copyright (C) 2007 Ruben Pollan Bella <meskio@amedias.org>             *
 *                                                                        *
 *  This file is part of TuDu.                                            *
 *                                                                        *
 *  TuDu is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation; either version 3 of the License.        *
 *                                                                        *
 *  TuDu is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#ifndef DATA_H
#define DATA_H

#include <list>
#include <stack>
#include <string>
#include "text.h"
#include "date.h"
using namespace std;


class ToDo;
class iToDo;
typedef ToDo* pToDo;

class ToDo
{
public:
	ToDo(string t = "", bool isDone = false, string txt = "");
	~ToDo();

	string& getTitle();
	Text& getText();
	Date& deadline();
	bool& done();
	bool haveChild();
	int percent();
	int line;
	bool& getCollapse(); // real collapse
	bool& actCollapse(); // if must be collapse now
protected:
	string title;
	bool _done;
	Date _deadline;
	Text text;
	list<pToDo> childs;
	bool collapse; //real param
	bool cursor_in; //if the cursor is inside, use for actCollapse

	friend class iToDo;
};

/*
 * Iterator for ToDo class
 */
class iToDo 
{
public:
	iToDo(ToDo& t);

	iToDo& operator=(const iToDo& t);
	bool operator++();
	bool operator--();
	bool in();
	bool out();
	ToDo &operator*();
	ToDo *operator->();
	bool end();
	bool begin();
	int percentUp();
	void addChild(pToDo p);
	void addChildUp(pToDo p);
	void del();
	int depth();
protected:
	stack<list<pToDo>::iterator> path;
	stack<pToDo> parents;
	list<pToDo>::iterator cursor;
};

#endif
