
/**************************************************************************
 * Copyright (C) 2007 Ruben Pollan Bella <meskio@amedias.org>             *
 *                                                                        *
 *  This file is part of TuDu.                                            *
 *                                                                        *
 *  TuDu is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation; either version 3 of the License.        *
 *                                                                        *
 *  TuDu is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#include "date.h"

Date::Date(int day, int month, int year): _day(day), _month(month), _year(year) {}

int& Date::day(int d)
{
	if (d) _day = d;
	return _day;
}

int& Date::month(int m)
{
	if (m) _month = m;
	return _month;
}

int& Date::year(int y)
{
	if (y) _year = y;
	return _year;
}

bool Date::valid()
{
	return (1900 != _year);
}

#define SECONDS_IN_A_DAY (60*60*24)
int Date::daysLeft()
{
	time_t rawtime;
	time_t today;
	struct tm * timeinfo;
	int daysleft;

	time(&rawtime);
	timeinfo = localtime(&rawtime);
	timeinfo->tm_mday = _day;
	timeinfo->tm_mon = _month - 1;
	timeinfo->tm_year = _year - 1900;
	rawtime = mktime(timeinfo);
	today = time(NULL);
	daysleft = difftime(rawtime,today)/SECONDS_IN_A_DAY;
	return daysleft;
}
