
/**************************************************************************
 * Copyright (C) 2007 Ruben Pollan Bella <meskio@amedias.org>             *
 *                                                                        *
 *  This file is part of TuDu.                                            *
 *                                                                        *
 *  TuDu is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation; either version 3 of the License.        *
 *                                                                        *
 *  TuDu is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#ifndef INTERFACE_H
#define INTERFACE_H

#include <ncurses.h>
#include <stdio.h>
#include <map>
#include "window.h"
#include "data.h"
#include "config.h"
#include "parser.h"
#include "editor.h"

#define TREE_LINES  (LINES*3/4)
#define WTEXT_COLS  (COLS-2)
#define WTEXT_LINES (LINES-TREE_LINES-3)

class Interface
{
public:
	Interface(iToDo &t, Config &c, Writer &w);
	~Interface();

	void main();
private:
	Window *whelp;
	Window *wtree;
	Window *wtext;
	Window *winfo;
	iToDo &cursor;
	Config &config;
	Writer &writer;
	/* number of begin and end line of the todos in screen */
	int tree_begin, tree_end;
	pToDo copied;
	LineEditor lineEditor;
	DateEditor dateEditor;

	void infoMsg(const char str[]);
	void infoClear();
	void drawTitle();
	void drawTodo();
	void _drawTodo(int& line_counter);
	void eraseCursor();
	void drawCursor();
	void left();
	void right();
	void up();
	void down();
	void move_up();
	void move_down();
	void done();
	void del();
	void delDeadline();
	void paste();
	void pasteUp();
	bool editLine(string& str);
	void editDeadline();
	void addLine();
	void addLineUp();
	void modifyLine();
	void editText();
	void upText();
	void downText();
	void collapse();
	void save();
	void help();
};

#endif
